summaryrefslogtreecommitdiffstats
path: root/tests/ts/lsfd/mkfds-netns
diff options
context:
space:
mode:
authorDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-14 19:10:49 +0000
committerDaniel Baumann <daniel.baumann@progress-linux.org>2024-04-14 19:10:49 +0000
commitcfe5e3905201349e9cf3f95d52ff4bd100bde37d (patch)
treed0baf160cbee3195249d095f85e52d20c21acf02 /tests/ts/lsfd/mkfds-netns
parentInitial commit. (diff)
downloadutil-linux-cfe5e3905201349e9cf3f95d52ff4bd100bde37d.tar.xz
util-linux-cfe5e3905201349e9cf3f95d52ff4bd100bde37d.zip
Adding upstream version 2.39.3.upstream/2.39.3
Signed-off-by: Daniel Baumann <daniel.baumann@progress-linux.org>
Diffstat (limited to 'tests/ts/lsfd/mkfds-netns')
-rwxr-xr-xtests/ts/lsfd/mkfds-netns72
1 files changed, 72 insertions, 0 deletions
diff --git a/tests/ts/lsfd/mkfds-netns b/tests/ts/lsfd/mkfds-netns
new file mode 100755
index 0000000..cd110f6
--- /dev/null
+++ b/tests/ts/lsfd/mkfds-netns
@@ -0,0 +1,72 @@
+#!/bin/bash
+#
+# Copyright (C) 2022 Masatake YAMATO <yamato@redhat.com>
+#
+# This file is part of util-linux.
+#
+# This file is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This file is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+TS_TOPDIR="${0%/*}/../.."
+TS_DESC="netns associated with a fd"
+
+. "$TS_TOPDIR"/functions.sh
+ts_init "$*"
+ts_skip_nonroot
+ts_skip_docker
+
+. "$TS_SELF/lsfd-functions.bash"
+ts_check_test_command "$TS_CMD_LSFD"
+ts_check_test_command "$TS_HELPER_MKFDS"
+
+ts_cd "$TS_OUTDIR"
+
+PID=
+FD=3
+NAME_FD=
+NAME_NS=
+INO_FD=
+INO_NS=
+{
+ coproc MKFDS { "$TS_HELPER_MKFDS" netns "$FD"; }
+ if read -r -u "${MKFDS[0]}" PID; then
+ "${TS_CMD_LSFD}" -n -oNS.TYPE -p "${PID}" -Q "(FD == $FD)"
+ NAME_FD=$("${TS_CMD_LSFD}" -n -oNS.NAME -p "${PID}" -Q "(FD == $FD)")
+ NAME_NS=$("${TS_CMD_LSFD}" -n -oNS.NAME -p "${PID}" -Q '(ASSOC == "net")')
+ INO_FD=$( "${TS_CMD_LSFD}" -n -oINODE -p "${PID}" -Q "(FD == $FD)")
+ INO_NS=$( "${TS_CMD_LSFD}" -n -oINODE -p "${PID}" -Q '(ASSOC == "net")')
+
+ if [[ "$NAME_FD" = "$NAME_NS" ]]; then
+ echo "NAME_FD" == "NAME_NS": $?
+ else
+ echo "NAME_FD: $NAME_FD" == "NAME_NS: $NAME_NS": $?
+ fi
+
+ if [[ "$NAME_FD" = "net:[$INO_FD]" ]]; then
+ echo "NAME_FD" == "net:[INO_FD]": $?
+ else
+ echo "NAME_FD: $NAME_FD" == "net:[INO_FD: $INO_FD]": $?
+ fi
+
+ if [[ "$NAME_FD" = "net:[$INO_NS]" ]]; then
+ echo "NAME_FD" == "net:[INO_NS]": $?
+ else
+ echo "NAME_FD: $NAME_FD" == "net:[INO_NS: $INO_NS]": $?
+ fi
+
+ kill -CONT ${PID}
+ fi
+ wait "${MKFDS_PID}"
+} > "$TS_OUTPUT" 2>&1
+if [ "$?" == "$ENOSYS" ]; then
+ ts_skip "ioctl(fd, SIOCGSKNS) is not available"
+fi
+
+ts_finalize